import 'package:example/module/module.dart';
import 'package:flutter/material.dart';
import 'package:flutter_animate/flutter_animate.dart';
import 'package:flutter_mobx/flutter_mobx.dart';
import 'package:healthrian_ble_interface/healthrian_ble_interface.dart';
import 'package:rxdart/rxdart.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return const MaterialApp(
      // showPerformanceOverlay: true,
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({
    super.key,
  });

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  final _module = WearECG();
  late final _ble = _module.ble;

  @override
  Widget build(BuildContext context) {
    // return SafeArea(
    //   child: Scaffold(
    //     floatingActionButton: Column(
    //       mainAxisAlignment: MainAxisAlignment.end,
    //       crossAxisAlignment: CrossAxisAlignment.end,
    //       children: [
    //         FloatingActionButton(
    //           onPressed: () async {
    //             final a = await WearECG().ble.findConnectedDevices();
    //             print(a);
    //           },
    //         ),
    //         FloatingActionButton(
    //           onPressed: () async {
    //             final a = await WearECG().ble.findScannedDevices();
    //             print(a);
    //           },
    //         ),
    //         FloatingActionButton(
    //           onPressed: () async {
    //             WearECG().ble.connectAndRegister();
    //             // final a = await WearECG().ble.findScannedDevices();
    //             // a.first.device.connect();
    //           },
    //         ),
    //         FloatingActionButton(
    //           onPressed: () async {
    //             WearECG().ble.disconnectDevice();
    //             // final a = await WearECG().ble.findConnectedDevices();
    //             // a.first.disconnect();
    //           },
    //         ),
    //       ],
    //     ),
    //   ),
    // );

    return Scaffold(
      body: Center(
        child: Observer(
          builder: (context) {
            return SingleChildScrollView(
              child: Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  StreamBuilder(
                    stream: WinBle.connectionStream,
                    builder: (context, snapshot) {
                      return Text(snapshot.data.toString());
                    },
                  ),
                  StreamBuilder(
                    stream: _ble.streams.connection,
                    builder: (context, snapshot) {
                      return Text(snapshot.data.toString());
                    },
                  ),
                  StreamBuilder(
                    stream: _ble.streams.plotRTEcg?.pairwise(),
                    builder: (context, snapshot) {
                      final data = snapshot.data ?? [];
                      if (data.isEmpty) return const SizedBox();
                      final first = data[0];
                      final second = data[1];
                      print('${first?.pivot} ${second?.pivot}');
                      return SizedBox(
                        height: 200,
                        child: LineChart(
                          LineChartData(
                            lineBarsData: [
                              LineChartBarData(
                                spots: first?.l2 ?? [],
                              ),
                            ],
                          ),
                        ).animate().swap(
                          builder: (context, child) {
                            return LineChart(
                              LineChartData(
                                lineBarsData: [
                                  LineChartBarData(
                                    spots: second?.l2 ?? [],
                                  ),
                                ],
                              ),
                            );
                          },
                          duration: 36.ms,
                        ),
                      );
                      // print(snapshot.data);
                      // return Text('${second.value[0] - first.value[0]}');
                      return Text(snapshot.data.toString());
                    },
                  ),
                  StreamBuilder(
                    stream: _ble.streams.battery,
                    builder: (context, snapshot) {
                      return Text(snapshot.data.toString());
                    },
                  ),
                  StreamBuilder(
                    stream: _ble.streams.tap,
                    builder: (context, snapshot) {
                      return Text(snapshot.data.toString());
                    },
                  ),
                  StreamBuilder(
                    stream: _ble.streams.leadStateEcg,
                    builder: (context, snapshot) {
                      return Text(snapshot.data.toString());
                    },
                  ),
                ],
              ),
            );
          },
        ),
      ),
      floatingActionButton: Column(
        mainAxisAlignment: MainAxisAlignment.end,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          // FloatingActionButton(
          //   onPressed: () async {
          //     await WinBle.connect('cc:17:8a:a0:2a:18');
          //     await WinBle.disconnect('cc:17:8a:a0:2a:18');
          //   },
          // ),
          FloatingActionButton(
            onPressed: _ble.connectAndRegister,
            child: const Icon(Icons.bluetooth),
          ),
          FloatingActionButton(
            onPressed: _module.ecg?.start,
            child: const Icon(Icons.play_arrow),
          ),
          FloatingActionButton(
            onPressed: _module.ecg?.stop,
            child: const Icon(Icons.stop),
          ),
          FloatingActionButton(
            onPressed: _ble.disconnectDevice,
            child: const Icon(Icons.bluetooth_disabled),
          ),
          FloatingActionButton(
            onPressed: () {
              var prev = 0.0;
              _ble.streams.sampleEcg?.timeInterval().listen(
                (event) {
                  if (prev > event.value.first) print('$prev $event');
                  // print(event);
                  prev = event.value.first;
                },
                onDone: () => print('------------------'),
              );
            },
          ),
        ],
      ),
    );
  }
}
