import 'package:healthrian_ble_interface/healthrian_ble_interface.dart';

export 'commands_ble.dart';
export 'commands_ecg.dart';
export 'commands_oxi.dart';
export 'commands_function.dart';
export 'commands_save.dart';

class Commands {
  const Commands({
    this.ecg = const CommandsEcg(),
    this.oxi = const CommandsOxi(),
    this.ble = const CommandsBle(),
    this.func = const CommandsFunction(),
  });

  final CommandsEcg ecg;
  final CommandsOxi oxi;
  final CommandsBle ble;
  final CommandsFunction func;

  CommandsSave get save =>  CommandsSave(
    ecg: ecg,
    ble: ble,
    func: func,
    oxi: oxi,
  );

  List<int> get startEcg => func.packet(ecg.start);

  List<int> get stopEcg => func.packet(ecg.stop);

  List<int> get startOxi => func.packet(oxi.start);

  List<int> get stopOxi => func.packet(oxi.stop);

  List<int> get setDate => func.packet(ble.setDate, func.date());

  List<int> get firmUpdate => func.packet(ble.firmware);
}
